/* -LICENSE-START-
** Copyright (c) 2009 Blackmagic Design
**
** Permission is hereby granted, free of charge, to any person or organization
** obtaining a copy of the software and accompanying documentation covered by
** this license (the "Software") to use, reproduce, display, distribute,
** execute, and transmit the Software, and to prepare derivative works of the
** Software, and to permit third-parties to whom the Software is furnished to
** do so, all subject to the following:
** 
** The copyright notices in the Software and this entire statement, including
** the above license grant, this restriction and the following disclaimer,
** must be included in all copies of the Software, in whole or in part, and
** all derivative works of the Software, unless such copies or derivative
** works are solely in the form of machine-executable object code generated by
** a source language processor.
** 
** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
** IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
** FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
** SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
** FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
** ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
** DEALINGS IN THE SOFTWARE.
** -LICENSE-END-
*/
/* HDLinkAPI.h */

#ifndef __HDLink_API_h__
#define __HDLink_API_h__

#include <CoreFoundation/CoreFoundation.h>
#include <CoreFoundation/CFPlugInCOM.h>
#include <stdint.h>


// Interface UUIDs
// ============

// "0x8CF4BDB2,0x5A6D,0x4e78,0x9E,0x74,0xF3,0xE7,0x52,0x50,0xFF,0xF6"
#define LIBID_HDLinkAPI			(REFIID){0x8C,0xF4,0xBD,0xB2,0x5A,0x6D,0x4e,0x78,0x9E,0x74,0xF3,0xE7,0x52,0x50,0xFF,0xF6}

// "0x8CF4BDB2,0x5A6D,0x4e78,0x9E,0x74,0xF3,0xE7,0x52,0x50,0xFF,0xF6"
#define IID_IHDLinkIterator			(REFIID){0xD5,0xDB,0x5B,0x05,0x91,0x41,0x45,0x15,0x87,0x98,0x3F,0x90,0xCC,0x91,0x70,0x14}

// "0xC021B9E6,0xFED2,0x45fe,0xB5,0xD5,0x3D,0x17,0x93,0x29,0x1E,0xC8"
#define IID_IHDLink					(REFIID){0xC0,0x21,0xB9,0xE6,0xFE,0xD2,0x45,0xfe,0xB5,0xD5,0x3D,0x17,0x93,0x29,0x1E,0xC8}

// "0x941FE963,0xCAE9,0x4C26,0x9A,0x98,0xAE,0x36,0x36,0x6E,0xE5,0xD7"
#define IID_IHDLinkDiscovery		(REFIID){0x94,0x1F,0xE9,0x63,0xCA,0xE9,0x4C,0x26,0x9A,0x98,0xAE,0x36,0x36,0x6E,0xE5,0xD7}

// "0x88B01563,0x2CFF,0x40a7,0xA2,0xB0,0xA2,0x4B,0xBA,0x2B,0x41,0xCE"
#define CLSID_CHDLinkDiscovery		(REFIID){0x88,0xB0,0x15,0x63,0x2C,0xFF,0x40,0xa7,0xA2,0xB0,0xA2,0x4B,0xBA,0x2B,0x41,0xCE}

// "8D600A31-9050-4182-9608-B9D2B144D352"
#define IID_IHDLinkAttributes		(REFIID){0x8D,0x60,0x0A,0x31,0x90,0x50,0x41,0x82,0x96,0x08,0xB9,0xD2,0xB1,0x44,0xD3,0x52}

// "AAFD4EF3-44C9-44B5-96E6-0BE1004FE0DB"
#define IID_IHDLinkConfiguration	(REFIID){0xAA,0xFD,0x4E,0xF3,0x44,0xC9,0x44,0xB5,0x96,0xE6,0x0B,0xE1,0x00,0x4F,0xE0,0xDB}

// 4DF937B0-AC90-4E5B-9BA3-0FCCBCF64181
#define IID_IHDLink3DLUTConfiguration	(REFIID){0x4D,0xF9,0x37,0xB0,0xAC,0x90,0x4E,0x5B,0x9B,0xA3,0x0F,0xCC,0xBC,0xF6,0x41,0x81}

// Callbacks

// "0x0DEB181B,0x0541,0x425b,0xBD,0x57,0x55,0x70,0x40,0x3E,0x1E,0xF3"
#define IID_IHDLinkDeviceArrivalCallback	(REFIID){0x0D,0xEB,0x18,0x1B,0x05,0x41,0x42,0x5b,0xBD,0x57,0x55,0x70,0x40,0x3E,0x1E,0xF3}

// "0x2C923855,0x3B08,0x41A6,0x8B,0xAF,0x25,0xD6,0x42,0xB8,0xFA,0xF0"
#define IID_IHDLinkDeviceRemovalCallback	(REFIID){0x2C,0x92,0x38,0x55,0x3B,0x08,0x41,0xA6,0x8B,0xAF,0x25,0xD6,0x42,0xB8,0xFA,0xF0}

typedef uint32_t BMDHDLinkAttributeID;
enum {
	// Flags
	BMDHDLinkAttribute_Supports3dLUT = '3dLT',
	// Ints
	// Floats
	// Strings
};

typedef uint32_t BMDHDLinkConfigurationID;
enum {
	// Flags
	BMDHDLinkConfiguration_ScaleIllegalYUV = 'SYUV',
	// Ints
	// Floats
	// Strings
};

typedef struct tagLOOKUPTABLE_COLOR
{
	float	red;
	float	green;
	float	blue;
} LOOKUPTABLE_COLOR;

#if defined(__cplusplus)

/* Forward Declarations */ 
class IHDLinkDiscovery;
class IHDLink;

class IHDLinkDeviceArrivalCallback : public IUnknown
{
public:
	virtual void STDMETHODCALLTYPE HDLinkDeviceArrival (IHDLink *device) = 0;
	virtual ~IHDLinkDeviceArrivalCallback () {}
};

class IHDLinkDeviceRemovalCallback : public IUnknown
{
public:
	virtual void STDMETHODCALLTYPE HDLinkDeviceRemoval (IHDLink *device) = 0;
	virtual ~IHDLinkDeviceRemovalCallback () {}
};

class IHDLinkIterator : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE Next (IHDLink **hdlinkInstance) = 0;
	virtual ~IHDLinkIterator () {}
};

class IHDLinkDiscovery : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE CreateHDLinkIterator (IHDLinkIterator **iterator) = 0;
	virtual HRESULT STDMETHODCALLTYPE InstallDeviceAddedNotification (IHDLinkDeviceArrivalCallback *theCallback) = 0;
	virtual HRESULT STDMETHODCALLTYPE UninstallDeviceAddedNotification (void) = 0;
	virtual ~IHDLinkDiscovery () {}
};

class IHDLink : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE GetModelName (CFStringRef *modelName) = 0;
	virtual HRESULT STDMETHODCALLTYPE InstallDeviceRemovalNotification (IHDLinkDeviceRemovalCallback *theCallback) = 0;
	virtual HRESULT STDMETHODCALLTYPE UninstallDeviceRemovalNotification (void) = 0;
	virtual ~IHDLink () {}
};

class IHDLinkAttributes : public IUnknown
{
public:
	virtual ~IHDLinkAttributes () {}

	virtual HRESULT STDMETHODCALLTYPE	GetFlag (BMDHDLinkAttributeID cfgID, bool* value) = 0;
	virtual HRESULT STDMETHODCALLTYPE	GetInt (BMDHDLinkAttributeID cfgID, int64_t* value) = 0;
	virtual HRESULT STDMETHODCALLTYPE	GetFloat (BMDHDLinkAttributeID cfgID, double* value) = 0;
	virtual HRESULT STDMETHODCALLTYPE	GetString (BMDHDLinkAttributeID cfgID, CFStringRef* value) = 0;
};

class IHDLinkConfiguration : public IUnknown
{
public:
	virtual ~IHDLinkConfiguration () {}

	virtual HRESULT STDMETHODCALLTYPE	GetFlag (BMDHDLinkConfigurationID cfgID, bool* value) = 0;
	virtual HRESULT STDMETHODCALLTYPE	SetFlag (BMDHDLinkConfigurationID cfgID, bool value) = 0;

	virtual HRESULT STDMETHODCALLTYPE	GetInt (BMDHDLinkConfigurationID cfgID, int64_t* value) = 0;
	virtual HRESULT STDMETHODCALLTYPE	SetInt (BMDHDLinkConfigurationID cfgID, int64_t value) = 0;

	virtual HRESULT STDMETHODCALLTYPE	GetFloat (BMDHDLinkConfigurationID cfgID, double* value) = 0;
	virtual HRESULT STDMETHODCALLTYPE	SetFloat (BMDHDLinkConfigurationID cfgID, double value) = 0;

	virtual HRESULT STDMETHODCALLTYPE	GetString (BMDHDLinkConfigurationID cfgID, CFStringRef* value) = 0;
	virtual HRESULT STDMETHODCALLTYPE	SetString (BMDHDLinkConfigurationID cfgID, CFStringRef value) = 0;
};

class IHDLink3DLUTConfiguration : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE ReadActiveTable (LOOKUPTABLE_COLOR** table, uint32_t* cubeDimension, CFStringRef* tableName) = 0;
	virtual HRESULT STDMETHODCALLTYPE WriteTable (LOOKUPTABLE_COLOR table[], uint32_t cubeDimension, CFStringRef tableName, bool saveTableToNonvolatileStorage) = 0;
	virtual HRESULT STDMETHODCALLTYPE ResetTable (bool saveTableToNonvolatileStorage) = 0;
	virtual ~IHDLink3DLUTConfiguration () {}
};

extern "C" {
	IHDLinkDiscovery*		CreateHDLinkDiscoveryInstance (void);
};

#endif // __cplusplus

#endif		// __HDLink_API_h__

