/* -LICENSE-START-
** Copyright (c) 2009 Blackmagic Design
**
** Permission is hereby granted, free of charge, to any person or organization
** obtaining a copy of the software and accompanying documentation covered by
** this license (the "Software") to use, reproduce, display, distribute,
** execute, and transmit the Software, and to prepare derivative works of the
** Software, and to permit third-parties to whom the Software is furnished to
** do so, all subject to the following:
** 
** The copyright notices in the Software and this entire statement, including
** the above license grant, this restriction and the following disclaimer,
** must be included in all copies of the Software, in whole or in part, and
** all derivative works of the Software, unless such copies or derivative
** works are solely in the form of machine-executable object code generated by
** a source language processor.
** 
** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
** IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
** FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
** SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
** FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
** ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
** DEALINGS IN THE SOFTWARE.
** -LICENSE-END-
*/
/* HDLinkAPI_v3_0.h */

#ifndef BMD_HDLINK_API_V3_0_H_
#define BMD_HDLINK_API_V3_0_H_

#include "HDLinkAPI.h"

// "0xE408FE93,0xAB96,0x4582,0xA2,0x35,0xFE,0xCB,0xA3,0x2A,0x03,0xC3"
#define IID_I3DLookupTableConfiguration_v3_0	(REFIID){0xE4,0x08,0xFE,0x93,0xAB,0x96,0x45,0x82,0xA2,0x35,0xFE,0xCB,0xA3,0x2A,0x03,0xC3}

// use "unsigned long" except where it's not a 32-bit type
#ifdef __amd64__				// gcc macro
typedef uint32_t			BMDulong32_;
#elif defined __i386__ || defined __ppc__ // gcc macro
typedef unsigned long		BMDulong32_;
#else
#error Unknown architecture
#endif // architectures

#ifdef __cplusplus

class I3DLookupTableConfiguration_v3_0 : public IUnknown
{
public:
        virtual HRESULT STDMETHODCALLTYPE ReadActiveTable(LOOKUPTABLE_COLOR** table, BMDulong32_* cubeDimension, CFStringRef* tableName) = 0;
        virtual HRESULT STDMETHODCALLTYPE WriteTable(LOOKUPTABLE_COLOR table[], BMDulong32_ cubeDimension, CFStringRef tableName, bool saveTableToNonvolatileStorage) = 0;
        virtual HRESULT STDMETHODCALLTYPE ResetTable(bool saveTableToNonvolatileStorage) = 0;
		virtual							  ~I3DLookupTableConfiguration_v3_0() {}
};

#endif // __cplusplus

#endif // BMD_HDLINK_API_V3_0_H_
