/* -LICENSE-START-
** Copyright (c) 2009 Blackmagic Design
**
** Permission is hereby granted, free of charge, to any person or organization
** obtaining a copy of the software and accompanying documentation covered by
** this license (the "Software") to use, reproduce, display, distribute,
** execute, and transmit the Software, and to prepare derivative works of the
** Software, and to permit third-parties to whom the Software is furnished to
** do so, all subject to the following:
** 
** The copyright notices in the Software and this entire statement, including
** the above license grant, this restriction and the following disclaimer,
** must be included in all copies of the Software, in whole or in part, and
** all derivative works of the Software, unless such copies or derivative
** works are solely in the form of machine-executable object code generated by
** a source language processor.
** 
** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
** IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
** FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
** SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
** FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
** ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
** DEALINGS IN THE SOFTWARE.
** -LICENSE-END-
*/
// HDLinkLutRWTestDlg.h : header file
//

#pragma once

#include "HDLinkAPI.h"

#define MAX_HDLINK   1

enum {
	// LUT cube constants
	kLutCubePoints1D = 17,	 // aka "cube dimension"
	kLutCubePointMax1D = kLutCubePoints1D - 1,
	kLutCubePoints2D = kLutCubePoints1D * kLutCubePoints1D,
	kLutCubePoints3D = kLutCubePoints2D * kLutCubePoints1D,
};

class	m_pDelegate;

// CHDLinkLutRWTestDlg dialog
class CHDLinkLutRWTestDlg : public CDialog
{
// Construction
public:
	CHDLinkLutRWTestDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CHDLinkLutRWTestDlg();						// standard destructor
// Dialog Data
	enum { IDD = IDD_HDLINKLUTRWTEST_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support



// Implementation

private:
	unsigned int					m_DHLinkDeviceIndex;
	IHDLinkDeviceArrivalCallback*	m_pArrivalDelegate;
	IHDLinkDiscovery*				m_HDLinkDiscovery;
	IHDLink3DLUTConfiguration*    	m_Cur3DLookupTableConfiguration; 

	CComboBox						m_HDLinkDevsCombo;
	CButton							m_LutBrowsBtn;
	CButton							m_LutReadBtn;
	CButton							m_LutLoadBtn;
	CButton							m_HDLinkRestBtn;
	CButton							m_LutLoadNvBtn;
	CButton							m_HDLinkRestNvBtn;

	LOOKUPTABLE_COLOR				Lut3DTable[kLutCubePoints3D];


protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:	
	
	CStatic m_HDLinkDevsStatusLbl;
	void UpdateControls(bool EnableCtls);
	void DeviceAdded(IHDLink *Sender );
	void DeviceRemove(IHDLink *Sender , void* refCon);

	afx_msg BOOL	OnDeviceChange(UINT nEventType, DWORD_PTR dwData);

	afx_msg void	OnBnClickedHdlinkConnectBtn();
	afx_msg void	OnBnClickedOk();
	afx_msg void	OnBnClickedLutReadBtn();
	afx_msg void	OnBnClickedLutLoadBtn();
	afx_msg void OnClose();
	afx_msg void OnDestroy();
	afx_msg void OnStnClickedDeviceStatusLbl();
	afx_msg void OnBnClickedHdlinkResetBtn();
	afx_msg void OnBnClickedButton1();
	afx_msg void OnBnClickedLutLoadNvBtn();
	afx_msg void OnBnClickedHdlinkResetNvBtn();
};

class CHDLinkArrivalDelegate : public IHDLinkDeviceArrivalCallback
{
private:
	int						m_RefCount;
	CHDLinkLutRWTestDlg*	m_pController;

public:
	void*					m_RefCon;
	CHDLinkArrivalDelegate (CHDLinkLutRWTestDlg* pController);
	virtual ~CHDLinkArrivalDelegate ();
	virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID iid, LPVOID *ppv);
	virtual ULONG STDMETHODCALLTYPE AddRef(void);
	virtual ULONG STDMETHODCALLTYPE  Release(void);
	virtual HRESULT STDMETHODCALLTYPE  HDLinkDeviceArrival(IHDLink *Sender );

};

class CHDLinkRemovalDelegate : public IHDLinkDeviceRemovalCallback
{
private:
	int						m_RefCount;
	CHDLinkLutRWTestDlg*	m_pController;

public:
	void*					m_RefCon;
	CHDLinkRemovalDelegate(CHDLinkLutRWTestDlg* pController);
	virtual ~CHDLinkRemovalDelegate ();
	virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID iid, LPVOID *ppv);
	virtual ULONG STDMETHODCALLTYPE AddRef(void);
	virtual ULONG STDMETHODCALLTYPE  Release(void);
	virtual HRESULT STDMETHODCALLTYPE  HDLinkDeviceRemoval(IHDLink *Sender);

};
